<?php
/*
 /////////////////// DISCLAIMER ///////////////////////////
 THIS EXAMPLE CODE IS PROVIDED TO YOU ONLY ON AN "AS IS"
 BASIS WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
 MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 PAYPAL MAKES NO WARRANTY THAT THE SOFTWARE OR
 DOCUMENTATION WILL BE ERROR-FREE. IN NO EVENT SHALL THE
 COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ////////////////////////////////////////////////////////////
 */

//create access token to be passed in to this API call
include 'create-token.php';

//Print all errors
error_reporting(E_ALL);
ini_set("display_errors", 1);


//Initiate CURL and set the url endpoint
$ch = curl_init();
$url = 'https://api.sandbox.paypal.com/v1/customer/partner-referrals';
curl_setopt($ch, CURLOPT_URL, $url);

curl_setopt($ch, CURLOPT_SSLVERSION, CURL_SSLVERSION_TLSv1_2);

//Should to be set to true for security
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
//Should be set to 2 for security
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);

//Cert can be generated through mozilla firefox and is used when implementing security for VERIFYPEER and VERIFYHOST in the above
//curl_setopt($ch, CURLOPT_CAINFO, '/var/www/html/Example_REST_FP/cert/cacert.pem');

$BNCode = 'MyBnCode';
//Set the required headers
$headers = array(
		'Accept: application/json',
		'Content-Type: application/json',
		'Accept-Language: en_US',
        "Authorization: Bearer $accessToken",
        "PayPal-Partner-Attribution-Id: $BNCode"
);
curl_setopt($ch,CURLOPT_HTTPHEADER,$headers);

//Lets curl know we are using 'post' and not 'get' (false = 'get')
curl_setopt($ch, CURLOPT_POST, TRUE);

//Keep connection open until we get data back
curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);

//Reset the array
$vars = [];

//Specify partner generated tracking id for merchant
$partner_specific_identifiers['type'] = "TRACKING_ID";
$partner_specific_identifiers['value'] = "1506721846";
$customer_data['partner_specific_identifiers'] = array($partner_specific_identifiers);
$vars['customer_data'] = $customer_data;

//Store this id for later use, should be entered into your database
$_SESSION['trackingId'] = '1506721846';

//Specify the integration method and type
$rest_api_integration['integration_method'] = 'PAYPAL';
$rest_api_integration['integration_type'] = 'THIRD_PARTY';

//Specify all the features the merchant must give you permissions for
$feature_list = array("PAYMENT", "REFUND", "PARTNER_FEE", "DELAY_FUNDS_DISBURSEMENT","ADVANCED_TRANSACTIONS_SEARCH");
$rest_third_party_details['partner_client_id'] = "AcNEYyp4KIYuTLS9KOsZr9Ua0Gi2c4p5dOSfSnoYTL9ZgdpNyNEvTE6LaF60Xy89BkMGFFMw4HxSb5Tf";
$rest_third_party_details['feature_list'] = $feature_list;

//Specify your partner id and save this to your database
$api_integration_preference['rest_third_party_details'] = $rest_third_party_details;
$api_integration_preference['partner_id'] = "LKMBPUFVYHVYL";
$api_integration_preference['rest_api_integration'] = $rest_api_integration;
$_SESSION['partnerId'] = 'LKMBPUFVYHVYL';

//specify the capabilities you are requesting from the merchant
$requested_capabilities['capability'] = "API_INTEGRATION";
$requested_capabilities['api_integration_preference'] = $api_integration_preference;
$vars['requested_capabilities'] = array($requested_capabilities);

//Specify your logo, where you want the merchant returned to after they give you permissions and where
//to direct the merchant should the sign up link expire
$web_experience_preference['partner_logo_url'] = "https://example.com/paypal.jpg";
$web_experience_preference['return_url'] = "http://localhost/Sample_REST_PayPal_Commerce/trackSellerOnboardingStatus.php";
$web_experience_preference['action_renewal_url'] = "https://example.com/renew-prefill-url";
$vars['web_experience_preference'] = $web_experience_preference;

//Speciy that the merchant is give permission to share data with you the partner
$collected_consents['type'] = "SHARE_DATA_CONSENT";
$collected_consents['granted'] = true;
$vars['collected_consents']= array($collected_consents);

//Specify the products available to the merchant
$vars['products'] = array("EXPRESS_CHECKOUT", "PPCP");


//Build and set the json request
$json = json_encode($vars);
curl_setopt($ch, CURLOPT_POSTFIELDS, $json);

//Print the request
echo $json;

//get the response back
$response = curl_exec($ch);

//parse json into php array
$outArray = json_decode($response, true);

//Print the response
echo "<pre>";
print_r($outArray);
echo "</pre>";

//Close the connection
curl_close($ch);

// //Extract the link to redirect the merchant to in order to have them grant you your permissions
// $link = $outArray['links'][1]['href'];
// //echo $link;

// //Redirect the user to the link extracted earlier so they can give permissions
// header("Location: $link");


