<?php
/*
 /////////////////// DISCLAIMER ///////////////////////////
 THIS EXAMPLE CODE IS PROVIDED TO YOU ONLY ON AN "AS IS"
 BASIS WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
 MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 PAYPAL MAKES NO WARRANTY THAT THE SOFTWARE OR
 DOCUMENTATION WILL BE ERROR-FREE. IN NO EVENT SHALL THE
 COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ////////////////////////////////////////////////////////////
 */

//Start the PHP session
session_start();

//Get the access token from the session data
$accessToken = $_SESSION['accessToken'];

//Get the merchant tracking id from the session data
$trackingId = $_SESSION['trackingId'];

//Get the  partner id from the session
$partnerId = $_SESSION['partnerId'];

//Print all errors
error_reporting(E_ALL);
ini_set("display_errors", 1);


//Initiate CURL and set the url endpoint pasing the partner id and the merchant tracking id
$ch = curl_init();
$url = "https://api.sandbox.paypal.com/v1/customer/partners/$partnerId/merchant-integrations?tracking_id=$trackingId";
curl_setopt($ch, CURLOPT_URL, $url);

curl_setopt($ch, CURLOPT_SSLVERSION, CURL_SSLVERSION_TLSv1_2);

//Should to be set to true for security
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
//Should be set to 2 for security
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);

//Cert can be generated through mozilla firefox and is used when implementing security for VERIFYPEER and VERIFYHOST in the above
//curl_setopt($ch, CURLOPT_CAINFO, '/var/www/html/Example_REST_FP/cert/cacert.pem');

$BNCode = 'MyBnCode';
//Set the required headers
$headers = array(
    'Content-Type: application/json',
    "Authorization: Bearer $accessToken",
    "PayPal-Partner-Attribution-Id: $BNCode"
);
curl_setopt($ch,CURLOPT_HTTPHEADER,$headers);

//Lets curl know we are using 'get' and not 'post' (true = 'post')
curl_setopt($ch, CURLOPT_POST, FALSE);

//Keep connection open until we get data back
curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);


//get the response back
$response = curl_exec($ch);


//parse json into php array
$outArray = json_decode($response, true);

//Print the response
print_r($_GET);
//Array ( [merchantId] => 1506721846 [merchantIdInPayPal] => 4SBV8P49XCTL8 [permissionsGranted] => true
//[accountStatus] => BUSINESS_ACCOUNT [consentStatus] => true [productIntentID] => addipmt 
// [isEmailConfirmed] => true 
// [returnMessage] => To start accepting payments, please log in to PayPal and finish signing up. ) 

$_SESSION['payee'] = $_GET['merchantIdInPayPal'];

//Print the response
// echo "<pre>";
// print_r($outArray);
// echo "</pre>";

//Close the connection
curl_close($ch);
$_SESSION['transactions'] = null;

?>

 <!DOCTYPE html>
<html>
<head>
<title>Page Title</title>
</head>
<body>


<a href="http://localhost/Sample_REST_PayPal_Commerce/doTransaction.php">Start taking orders</a>


</body>
</html> 


